#include "1ware.h"
#include <stdio.h>

volatile static unsigned	uW1Mode=0;	//1- 
volatile static unsigned	uW1Status=0;
volatile static unsigned	uW1Ret;

void	W1Init(void)
{
  W1_O_DIR;  
  W1_I_DIR;
  W1_TTCR=2;			// T
  W1_TCCR=0;			// 
  W1_TEMR=0;			// 
  W1_TPR=PCLK/1000000;		//R ,  1000		
  W1_TMCR=4|1;			//      0- 
  VICIntSelect&=~(1<<W1_VIC);//   ,  IRQ 
  W1_VICVectAddr=(unsigned long)W1Int;
  W1_VICVectCntl=0x20|W1_VIC;	//   
  VICIntEnable=1<<W1_VIC;	//   T

}

void	W1Int()
{
switch(uW1Mode)
	{
	  case	1:		//  
	  switch(uW1Status)
	  	{
		 case	0:	//  
		W1_TMR0=W1_RES2;		// 160us
		W1_O_CLR;			// 1
		W1_TTCR=2;			// T
		W1_TTC=0;
		W1_TTCR=1;			// T
		uW1Status=1; 
		break;   
		
		 case	1:			//
		uW1Ret=W1_I;   
		W1_TMR0=W1_RES3;		// 320us
		W1_TTCR=2;			// T
		W1_TTC=0;
		W1_TTCR=1;			// T
		uW1Status=2; 
		break;   
		
		 case	2:			//
		W1_TTCR=2;			// T
		uW1Status=3; 
		uW1Mode=0;
		break;   
		
		default:
		  break;
	  	}
	  break;
	  
	  case	2:		// - 0
	  switch(uW1Status)
	  	{
		case	0:	// 0
		W1_O_CLR;			// 1
		W1_TTCR=2;			// T
		uW1Status=3; 
		uW1Mode=0;
		break;   
		}
	  break;
	  
	  case	3:		// - 1, 
	  switch(uW1Status)
	  	{
		case	0:	// 0
		W1_O_CLR;			// 1
		W1_TTCR=2;			// T
		W1_TMR0=W1_SEND2;		// 320us
		W1_TTC=0;
		W1_TTCR=1;			// T
		uW1Status=1; 
		break;  
		
		case	1:			//
		uW1Ret=W1_I;  
		W1_TTCR=2;			// T
		W1_TMR0=W1_SEND3;		// 320us
		W1_TTC=0;
		W1_TTCR=1;			// T
		uW1Status=2; 
		break;   
		
		 case	2:			//
		W1_TTCR=2;			// T
		uW1Status=3; 
		uW1Mode=0;
		break;   
		
		default:
		  break;
		}
	  break;  
	}

  
W1_TIR=0xFF;			//   T
}

int	W1Reset(void)
{
uW1Mode=1;
uW1Status=0;
W1_TTCR=2;			//
W1_TTC=0;

W1_TMR0=W1_RES1;		// 480us
W1_O_SET;			// 0
W1_TTCR=1;			// T
 
while(uW1Status<3);

return	uW1Ret?0:1;
}

void	W1Send0(void)
{
uW1Mode=2;
uW1Status=0;
W1_TTCR=2;			//
W1_TTC=0;

W1_TMR0=W1_SEND0;		// 480us
W1_O_SET;			// 0
W1_TTCR=1;			// T
 
while(uW1Status<3);
}


int	W1Rec(void)
{
uW1Mode=3;
uW1Status=0;
W1_TTCR=2;			//
W1_TTC=0;

W1_TMR0=W1_SEND1;		// 480us
W1_O_SET;			// 0
W1_TTCR=1;			// T


  
while(uW1Status<3);
return	uW1Ret;
}

void	W1Send1(void)
{
W1Rec();
}

void	W1SendCommand(unsigned char com)
{
int	i;

for(i=0;i<8;i++)
	{
  	if(com&1)
    		W1Send1();
  	else
    		W1Send0();
  	com>>=1;
	}
}

void	W1SendAdr(unsigned long long llW1Adr)
{
int	i;

for(i=0;i<64;i++)
	{
  	if(llW1Adr&1)
    		W1Send1();
  	else
    		W1Send0();
  	llW1Adr>>=1;
	}
}

int	W1Load(unsigned char ucComm,unsigned long long *pllW1Adr,int iKolAdr)
{
int 	iKonfl;
int	iKol;
int	nBit,nBitOld=0;
int	iRecBit1,iRecBit2;
unsigned long long ullRes,ullMask;

for(iKol=0;iKol<iKolAdr;iKol++)
	{				//  
	iKonfl=0;
	if(!W1Reset())
	  	return	0;		//      
	W1SendCommand(ucComm);
//	printf("%X",ucComm);
	for(ullRes=0,ullMask=1,nBit=0;nBit<64;nBit++,ullMask<<=1)
		{			//   
		iRecBit1=W1Rec();
		iRecBit2=W1Rec();
//		printf("; %X",iRecBit1);
//		printf(" %X",iRecBit2);
//		printf(" %llX",ullRes);
		if(iRecBit1&&iRecBit2)
		  	return	0;	//
		if(iRecBit1!=iRecBit2)
			{		// 
			if(iRecBit1)
				{
			  	ullRes|=ullMask;
				W1Send1();
				}
			else
				W1Send0();
			continue;
			}
		iKonfl++;			// (  0  1)
		if(nBit=nBitOld)
			{		//   ,   0,   1
		  	ullRes|=ullMask;
			W1Send1();
			}
		else
			{		//    ,  0
			nBitOld=nBit;
			W1Send0();
			}
		}
//		printf(" %llX",ullRes);
	if(!W1ChkCRC(ullRes))
	  	return	0;
	*(pllW1Adr++)=ullRes;
//		printf(" %llX %d",ullRes,iKol);
	if(!iKonfl)
		{
		iKol++;
	  	break;
		}
	}
return iKol;
}

void	W1CalkCRCByte(unsigned char b,unsigned char *pCRC)
{
int	i,i1;

for(i=0;i<8;i++,b>>=1)
  	{
	i1=((*pCRC)&1)^(b&1);
	if(!i1)
	  	*pCRC>>=1;
	else
		{
		*pCRC^=0x18;
		*pCRC>>=1;
		*pCRC|=0x80;
		}
  	}
}

unsigned char W1CalkCRC(unsigned long long z,int l)
{
unsigned char ucCRC;
int		i;
  
  ucCRC=0;
  l>>=3;			// 
  for(i=0;i<l;i++,z>>=8)
  	{
	W1CalkCRCByte(z&0xFF,&ucCRC);
  	}
return ucCRC;
}

int	W1ChkCRC(unsigned long long z)
{
 unsigned char ucCRC_I;

  ucCRC_I=z>>56;
  return ucCRC_I==W1CalkCRC(z,56)?1:0;
}

unsigned char W1GetByte(void)
{
unsigned char	m,b;
int		i;
for(i=0,b=0,m=1;i<8;i++,m<<=1)
	{
	if(W1Rec())
	  	b|=m;
	}
return b;
}
