#include "init.h"
#include	"my_irq.h"
#include "my_uart.h"
#include "1ware.h"

extern volatile unsigned long	ulTick;

void PRC_Init_PLL(void)
{
  		//  PLL
  PLLCFG_bit.MSEL=4;
  PLLCFG_bit.PSEL=1;
  PLLFEED=0xaa;
  PLLFEED=0x55;
  PLLCON_bit.PLLE=1;	// PLL
  PLLFEED=0xaa;
  PLLFEED=0x55;
  while(!(PLLSTAT&PLOCK));	//  
  PLLCON_bit.PLLC=1;	//   
  PLLFEED=0xaa;
  PLLFEED=0x55;
}

void PRC_Init_MAM(void)
{
		//    
  MAMCR_bit.MODECTRL=0;		// 
  MAMTIM_bit.CYCLES=3;		//  CCLK>40
  MAMCR_bit.MODECTRL=2;		// 
  VPBDIV_bit.VPBDIV=0;		//  4  PCLK
}

void PRC_Init_T0(void)
{
  PINSEL0_bit.P0_5=2;		// 0_5    1  0
  
  T0TCR=0;			// T0
  T0CCR=0;			// 
  T0EMR=0;			// 
  T0PC=0;			//R  = 1
  T0MR1=PCLK/1000;		// ,  1000
  T0EMR=0xC0;			//   1  
  T0MCR=0x8|0x10;			//      1- 
  T0TCR=1;			// 
}

#pragma vector=IRQV
__irq __arm void	IRQ_int(void)
{
  void	(*i_f)();
  unsigned long v;
  
  v=VICVectAddr;
  if(v)
  {
    i_f=(void(*)())v;
    (*i_f)();
  }
  VICVectAddr=0;		//C   VIC
}

void PRC_Init_VIC(void)
{
  MEMMAP=0;			//2- , 0- 
  
  VICProtection=0;		//    VIC   
  VICIntEnClear=0xFFFFFFFF;	//  
  VICDefVectAddr=0;		//     
  VICIntSelect&=~(1<<VIC_TIMER0);//   0,  IRQ 
  VICVectAddr0=(unsigned long)T0Int;
  VICVectCntl0=0x20|VIC_TIMER0;	//   0
  VICIntEnable=1<<VIC_TIMER0;	//   T0

}


void PRCInit(void)
{
  __disable_interrupt();
  		//  -
  //SCS=0;
  PINSEL0=0;
  PINSEL1=0;
  PINSEL2=0;
  PRC_Init_PLL();
  PRC_Init_MAM();
  PRC_Init_T0();
  PRC_Init_VIC();
  __enable_interrupt();
  U0Init();
  U1Init();
  W1Init();
}


